//Just seting up our variables to use throughout the program
var startText = 'Start typing to search Facebook posts<span class="blink"> &#9615;</span>', //The default text to preload and resort back to for typing
	string = '', 	//The string variable for searches
	text = $('#text'), 
	message = $('#message'), 
	canvas = document.getElementById("canvas"), 
	ctx = canvas.getContext('2d'), 
	mouse = new Mouse(), 
	activeCount = 0, 
	rnd;

//Fluid system controls & variables
Particle.all = [];		//The array to store all of the particles on the screen, this gets loaded and emtpyed often
Particle.equil = 200;	//equilibrium
Particle.maxv = 300;	//the maximum velocity
Particle.res = .95; //particle resistance

Target.all = [];	//The array to store the location of all of the attrative targets
function Target(x, y) {		//object of new target location to be pushed into the target array
	this.x = x;
	this.y = y;
	this.m = 10;
	Target.all.push(this);
}

//on document load
$(function() {
	s = startText;	//set the string/search variable to the start text
	text.html(s).fadeIn(1300);
	setInterval(blink, 1000);

	//deal with auto resizing of the canvas element to scale to fit the screen
	canvas.height = $(window).height();
	canvas.width = $(window).width();
	$(window).resize(function() {
		canvas.height = $(window).height();
		canvas.width = $(window).width();
	});

	$('input').val('abc').focus();

	//function to deal with all the bullshit in Chrome while using the backspace (even with return false)
	function handleKeys(e){
		$('input').val('abc').focus();

		var cKey = e.which;
		if(!cKey) {
			cKey=e.keyCode;
		}

		if (string === startText) {
			string = String.fromCharCode(cKey);
			if (s !== startText && string !== '' ) { hitAPI(); }
		} else if (cKey == '8' && string === startText) { //Backspace
			string = '';
			msgFade();
		} else if (cKey == '8' && string.length == 0) { //Backspace
			string = startText;
			msgFade();
		} else if (cKey == '8' && string.length > 0) { //Backspace
			string = string.slice(0,-1);
			msgFade();
			if (s !== startText && string !== '' ) { hitAPI(string); }
		} else {
			string = string + String.fromCharCode(cKey);
			hitAPI(string);
		}
		text.html(string);	
		return false;
	}

$(document).keydown(function(e){
	var cKey = e.which;
		if(!cKey) {
			cKey=e.keyCode;
		}
	if(cKey == '8' && navigator.userAgent.toLowerCase().indexOf('chrome') > -1) { //find chrome, if so use the other key function
		handleKeys(e);
		return false;
	}
});

	$(document).keypress(handleKeys);

	setInterval(run, 14);

	$(canvas).click(function() {
		message.fadeOut(1000, function() { message.html(''); });
		new Target(mouse.x, mouse.y);
		setTimeout(clearTargets,10000);
	});

	$('#about').toggle(function() {
		$('body').prepend('<div class="box f"></div>').css('display: none');
		text.fadeOut('slow');
		msgFade();
		$('.box').html('<div id="w"><h1>Social Bubble.<h1><h2>by Max Nanis (<a href="http://twitter.com/x0xMaximus" target="_blank">x0xMaximus</a>)</h2><h3>About</h3><p>This is an HTML5 canvas experiment made at <a href="http://twitter.com/skookum" target="_blank">Skookum Labs</a> in <a href="http://10k.aneventapart.com/" target="_blank">under 10KB of code</a> to visualize what people are discussing on Facebook. Every bubble you see represents a wall post that contains the text you have entered. A bubble\'s size is determined by the length of the wall post. When viewing the contents of each bubble, feel free to click the user\'s name to see their profile.</p><p>The bubbles are in a simulated environment where their properties influences the actions and behaviors of the others. This interaction is intended to simulate the way people\'s activities on social networking sites can influence and distribute information collectively. Click on the canvas to attract the bubbles and interact with them using the mouse.</p><h3>Tools</h3><p>This is built using the <a href="http://developers.facebook.com/" target="_blank">Facebook Graph API</a>. I suggest you familiarize yourself with online privacy if you have not already done so and reconsider how much you share using social profiles.</p><h3>Share</h3><a class="button r" href="http://twitter.com/share?text=I%20just%20used%20Social%20Bubble%20to%20search%20what%20people%20are%20saying%20on%20Facebook&via=x0xMaximus&url='+document.location+'">Tweet this!</a><div>').hide();
		$('.box').fadeIn('slow');

	}, function() {
		text.fadeIn('slow');
		$('.box').fadeOut('slow', function() {
			$(this).remove();
		});
	});

});	

//######################End of page onload

function clearTargets() {
	Target.all = [];
}

function blink() {
	$('.blink').fadeOut('slow', function() {
		$(this).fadeIn();
	});
}

function msgFade() {
	message.fadeOut(1000, function() { message.html(''); });
}

function hitAPI(q) {
	$.getJSON('http://graph.facebook.com/search?q='+encodeURI(string.trim())+'&type=post&callback=?', function(json) {
	if(q === string)	{ //to only loop through the most recent search queries
		activeCount = activeCount+1;		
			$.each(json.data, function (i, f) {
				var z = f.message;
				if (z && z.length < 240){
					rand = Math.random();
					new Particle(rand, z.length / 3.6, f.from.id, f.from.name, z, f.created_time, activeCount);
				}
			});

		for (i in Particle.all) { (Particle.all[i].api !== activeCount) ? message.html('<p>Sorry, nothing found - please try again</p>').fadeIn('fast').show() : message.html(''); }
	}
	});
}


//here is the particle object that will store everyting about that bubble and the post that bubble repersents 
function Particle(r, l, f, name, post, t, a) {
		this.x = r * canvas.width;
		this.y = canvas.height+l;
		this.vx = r * 20 - 10;
		this.vy = r * 20 - 10;
		this.r = [l, l, l * 1.6];
		this.tr = this.r[1];
		this.rv = 0;
		this.k = .1;
		this.id = f;
		this.name = name;
		this.post = post;
		this.color = rC();
		this.ago = t;
		this.api = a;
		this.alpha = 1;
	Particle.all.push(this);
}

function rC() {
	function c() {
		return Math.floor(Math.random()*256).toString(16);
	}
	return '#'+c()+c()+c();
}

Particle.prototype.bouncify = function() {
	this.rv += this.k * (this.tr - this.r[0]);
	this.r[0] += this.rv;
	this.rv *= .6;
};

//simple & useful return the sign of the number by deviding abs of it over it so it is either -1 or 1
Particle.sign = function(n) {
	if (n === 0) return 0;
	return (Math.abs(n) / n);
};

Particle.prototype.dist = function(x, y) {
	var dx = x - this.x;
	var dy = y - this.y;
	return Math.sqrt(dx * dx + dy * dy);
};

Particle.prototype.apply_forces = function() {

	if (Math.abs(this.vx) >= Particle.maxv) {
		this.vx = Particle.maxv * Particle.sign(this.vx);
	}
	if (Math.abs(this.vy) >= Particle.maxv) {
		this.vy = Particle.maxv * Particle.sign(this.vy);
	}

	if (this.x < (0 + this.r[0])) {
		this.x = 0 + this.r[0];
		this.vx = Math.abs(this.vx);
	}
	else if (this.x > (canvas.width -  this.r[0])) {
		this.x = canvas.width -  this.r[0];
		this.vx = -Math.abs(this.vx);
	}
	if (this.y < (0 + this.r[0])) {
		this.y = 0 + this.r[0];
		this.vy = Math.abs(this.vy);
	}
	else if (this.y > (canvas.height -  this.r[0])) {
		this.y = canvas.height -  this.r[0];
		this.vy = -Math.abs(this.vy);
	}
	this.x += this.vx;
	this.y += this.vy;	

	this.vx *= Particle.res;
	this.vy *= Particle.res;
};

Particle.prototype.find_target = function() {
	var t; 
	for (var i in Target.all) {
		t = Target.all[i];

		var dx = t.x - this.x;
		var dy = t.y - this.y;
		var dist = Math.sqrt(dx * dx + dy * dy);

		if (dist < t.m) return;
		this.vx += 10 * t.m * Particle.sign(dx) / dist;
		this.vy += 10 * t.m * Particle.sign(dy) / dist;
	}
};

Particle.prototype.rise = function() {
		this.vy -= this.y / (canvas.height*1.5);
};

Particle.prototype.repel = function(x, y) {
	var dx = x - this.x;
	var dy = y - this.y;
	var dist = this.dist(x, y);
	var fx = Particle.sign(dx) * Math.min(25, 100 / (dist));
	var fy = Particle.sign(dy) * Math.min(25, 100 / (dist));
	this.vx += fx;
	this.vy += fy;
};

Particle.prototype.isUnder = function(x, y) {
	var dx = x - this.x;
	var dy = y - this.y;
	var distance = Math.sqrt(dx * dx + dy * dy);
	return (distance < this.tr);
};

function Mouse() {
	this.x = 0;
	this.y = 0;
}

//to check if the mouse is above a bubble and if so add it to the message div
canvas.addEventListener('mousemove', function(e) {
	mouse.x = e.clientX;
	mouse.y = e.clientY;
	var ms, p;
	for (var i in Particle.all) {
		p = Particle.all[i];
		if (p.isUnder(e.clientX, e.clientY)) {
			p.tr = p.r[2];
			ms = '<img class="pic r"src="http://graph.facebook.com/'+p.id+'/picture" /><p>'+p.post+'</p><p><a href="http://www.facebook.com/profile.php?id='+p.id+'&v=wall"target="_blank"style="color:'+p.color+';text-decoration: none;">'+p.name+'</a></p>';

			message.html('').hide().html(ms).fadeIn().show();

		} else {
			p.tr = p.r[1];
		}
	}
}, false);

//the draw function for the canvas to put err thing on the screen
function run() {
	canvas.width = canvas.width;	//this is a clever hack to clear the canvas and not draw a clear rect (SO MUCH FASTER)

	var i, p, o;
	for (i in Particle.all) {
		p = Particle.all[i];
		p.repel(mouse.x, mouse.y);
		p.bouncify();
		p.rise();
		p.find_target();
	}

	for (i in Particle.all) {
		o = Particle.all[i];
		o.apply_forces();

		//check if alpha is 0 and if so remove from the array to speed it up!
		(o.api == activeCount) ? o.alpha = 1 : o.alpha = o.alpha - .01;
		if(o.alpha <= .01) { o.remove(i); }
		o.render(o.alpha);
	}


	//fixes bug in chrome to remove artifacts from bubbles by forcing a draw on the entire screen
	ctx.clearRect(0,0,1,1);
	ctx.clearRect(canvas.width-2, canvas.height-2, 1,1);
}

Particle.prototype.render = function(a) {
	//drawing function for the bubbles onthe page, pass in alpha so they fade away
	ctx.globalAlpha = a;
	ctx.fillStyle = this.color;
	ctx.beginPath();

	ctx.shadowOffsetX = 0;
	ctx.shadowOffsetY = 0;
	ctx.shadowBlur = 4;
	ctx.shadowColor = '#37374C';

	ctx.arc(~~this.x, ~~this.y, ~~this.r[0], 0, Math.PI * 2, false);	//~~ get floor and are much much faster, (no float with pixels)
	ctx.fill();
};

//function to take out old posts from the particle array
Particle.prototype.remove = function(from, to) {
	var rest = Particle.all.slice((to || from) + 1 || Particle.all.length);
	Particle.all.length = from < 0 ? Particle.all.length + from : from;
	return Particle.all.push.apply(Particle.all, rest);
};