#! /bin/sh

# Skookum JS + CSS deployment compression script
# v.1.0
#
# "Compiles" *.js recursively in JS_DIR -> JS_DIR/compressed.js
# Compresses CSS_SOURCES in listed order -> CSS_DIR/compressed.css
# 
# max@skookum.com for Social Bubbles

# Step 1. Configure these per-project
# Since stylesheets cascade, order is important

JS_DIR=./
CSS_DIR=./


# Step 2. Paths to the compression software

GOOGLE_CLOSURE=../build_tools/closure_compiler.jar
YUI_COMPRESSOR=../build_tools/yuicompressor-2.4.2.jar


# Step 3. Below, there is a list of .js files and a list of .css files.
# Just put your files in the list, and all of them will be compressed together.

# Leave these alone unless you want to relocate the compressed files

JS_TARGET=$JS_DIR/Chrome_app_min/app.js
CSS_TARGET=$CSS_DIR/Chrome_app_min/style.css

HERE=`pwd`

echo "Compiling JavaScript files from $JS_DIR with $GOOGLE_CLOSURE into $JS_TARGET..."

java -jar $GOOGLE_CLOSURE --compilation_level SIMPLE_OPTIMIZATIONS --summary_detail_level 3 \
--js Chrome_app/app.js \
--js_output_file $JS_TARGET


echo "Compressing CSS files into $CSS_TARGET..."
cd $CSS_DIR

cat \
Chrome_app/style.css \
| java -jar $HERE/$YUI_COMPRESSOR --type css > $HERE/$CSS_TARGET

cd $HERE
